//
// zedit - simple text editor
// Copyright (C) 2004-2005 Bryan Beicker <tokiko@tokiko.net>
//
// This file is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License (Version 2)
// as published by the Free Software Foundation.
//
// This file is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//

#ifndef MAIN_H
#define MAIN_H

#define VERSION			"0.2.2"

#define ZGTK_DIALOG_CLOSE	0
#define ZGTK_DIALOG_CANCEL	1
#define ZGTK_DIALOG_SAVE	2
#define ZGTK_DIALOG_DONT_SAVE	3

// zedit.z.c
void zedit_create();
gboolean zedit_unload(GtkWidget *, GdkEvent *, gpointer);
void zedit_destroy(GtkWidget *, gpointer);
void new_button_click();
void open_button_click();
void save_button_click();
void save_as_button_click();
void cut_button_click();
void copy_button_click();
void paste_button_click();
void about_button_click();
void textbox_change();
void open_file(char *);
void textbox_selection_change();

// util.c
GtkWidget * dialog;
void about_dialog(GtkWidget *, char **, char *, char *, char *);
int save_question_dialog(GtkWidget *);
int error_dialog(GtkWidget *, gchar *);

// globals
GtkWidget * zedit_window;
GtkWidget * view;
GtkTextBuffer * buffer;
GtkWidget * status;
gchar * file_name;
int dirty;

#endif
