//
// zedit - simple text editor
// Copyright (C) 2004-2005 Bryan Beicker <tokiko@tokiko.net>
//
// This file is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License (Version 2)
// as published by the Free Software Foundation.
//
// This file is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//

#include <gtk/gtk.h>		// gtk
#include "main.h"
#include "zedit.xpm"
#include "new.xpm"
#include "open.xpm"
#include "save.xpm"
#include "save_as.xpm"
#include "cut.xpm"
#include "copy.xpm"
#include "paste.xpm"
#include "about.xpm"


gboolean new_button_clicked(GtkWidget * widget, GdkEventButton * event, gpointer data)
{
	new_button_click();
	
	return TRUE;
}


gboolean open_button_clicked(GtkWidget * widget, GdkEventButton * event, gpointer data)
{
	open_button_click();
	
	return TRUE;
}


gboolean save_button_clicked(GtkWidget * widget, GdkEventButton * event, gpointer data)
{
	save_button_click();
	
	return TRUE;
}


gboolean save_as_button_clicked(GtkWidget * widget, GdkEventButton * event, gpointer data)
{
	save_as_button_click();
	
	return TRUE;
}


gboolean cut_button_clicked(GtkWidget * widget, GdkEventButton * event, gpointer data)
{
	cut_button_click();
	
	return TRUE;
}


gboolean copy_button_clicked(GtkWidget * widget, GdkEventButton * event, gpointer data)
{
	copy_button_click();
	
	return TRUE;
}


gboolean paste_button_clicked(GtkWidget * widget, GdkEventButton * event, gpointer data)
{
	paste_button_click();
	
	return TRUE;
}


gboolean about_button_clicked(GtkWidget * widget, GdkEventButton * event, gpointer data)
{
	about_button_click();
	
	return TRUE;
}


void accel_ctrl_n(GtkAccelGroup * accelgroup, GObject * arg1, guint arg2, GdkModifierType arg3, gpointer data)
{
	new_button_click(NULL, NULL, NULL);
}


void accel_ctrl_o(GtkAccelGroup * accelgroup, GObject * arg1, guint arg2, GdkModifierType arg3, gpointer data)
{
	open_button_click(NULL, NULL, NULL);
}


void accel_ctrl_s(GtkAccelGroup * accelgroup, GObject * arg1, guint arg2, GdkModifierType arg3, gpointer data)
{
	save_button_click(NULL, NULL, NULL);
}


void buffer_changed(GtkEntry * widget, gpointer data)
{
	textbox_selection_change();
	textbox_change();
}


void buffer_mark_set(GtkTextBuffer * textbuffer, GtkTextIter * arg1, GtkTextMark * arg2, gpointer data)
{
	textbox_selection_change();
}

	
void zedit_create()
{
	zedit_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(zedit_window), "zedit");
	gtk_widget_set_size_request(zedit_window, 700, 500);
	GTK_WINDOW(zedit_window)->allow_shrink = TRUE;

	GdkPixbuf * pixbuf;
	pixbuf = gdk_pixbuf_new_from_xpm_data((const char **) zedit_xpm);
	gtk_window_set_icon(GTK_WINDOW(zedit_window), pixbuf);

	GtkWidget * table;
	table = gtk_table_new(3, 1, FALSE);
	gtk_widget_show(table);
	gtk_container_add(GTK_CONTAINER(zedit_window), table);

	GtkWidget * toolbar;
	toolbar = gtk_toolbar_new();
	gtk_widget_show(toolbar);
	gtk_table_attach(GTK_TABLE(table), toolbar, 0, 1, 0, 1, (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), (GtkAttachOptions) (0), 0, 0);
	gtk_toolbar_set_style(GTK_TOOLBAR(toolbar), GTK_TOOLBAR_ICONS);

	GtkTooltips * tips;
	tips = gtk_tooltips_new();
	
	GdkPixbuf * new_pixbuf;
	GtkWidget * new_image;
	new_pixbuf = gdk_pixbuf_new_from_xpm_data((const char **) new_xpm);
	new_image = gtk_image_new_from_pixbuf(new_pixbuf);
	gtk_widget_show(new_image);

	GtkWidget * new_button;
	new_button = (GtkWidget *) gtk_tool_button_new(new_image, "new");
	gtk_tool_item_set_tooltip(GTK_TOOL_ITEM(new_button), GTK_TOOLTIPS(tips), "new", NULL);
	gtk_widget_show(new_button);
	gtk_container_add(GTK_CONTAINER(toolbar), new_button);

	GdkPixbuf * open_pixbuf;
	GtkWidget * open_image;
	open_pixbuf = gdk_pixbuf_new_from_xpm_data((const char **) open_xpm);
	open_image = gtk_image_new_from_pixbuf(open_pixbuf);
	gtk_widget_show(open_image);

	GtkWidget * open_button;
	open_button = (GtkWidget *) gtk_tool_button_new(open_image, "open");
	gtk_tool_item_set_tooltip(GTK_TOOL_ITEM(open_button), GTK_TOOLTIPS(tips), "open", NULL);
	gtk_widget_show(open_button);
	gtk_container_add(GTK_CONTAINER(toolbar), open_button);

	GdkPixbuf * save_pixbuf;
	GtkWidget * save_image;
	save_pixbuf = gdk_pixbuf_new_from_xpm_data((const char **) save_xpm);
	save_image = gtk_image_new_from_pixbuf(save_pixbuf);
	gtk_widget_show(save_image);

	GtkWidget * save_button;
	save_button = (GtkWidget *) gtk_tool_button_new(save_image, "save");
	gtk_tool_item_set_tooltip(GTK_TOOL_ITEM(save_button), GTK_TOOLTIPS(tips), "save", NULL);
	gtk_widget_show(save_button);
	gtk_container_add(GTK_CONTAINER(toolbar), save_button);

	GdkPixbuf * save_as_pixbuf;
	GtkWidget * save_as_image;
	save_as_pixbuf = gdk_pixbuf_new_from_xpm_data((const char **) save_as_xpm);
	save_as_image = gtk_image_new_from_pixbuf(save_as_pixbuf);
	gtk_widget_show(save_as_image);

	GtkWidget * save_as_button;
	save_as_button = (GtkWidget *) gtk_tool_button_new(save_as_image, "save as");
	gtk_tool_item_set_tooltip(GTK_TOOL_ITEM(save_as_button), GTK_TOOLTIPS(tips), "save as", NULL);
	gtk_widget_show(save_as_button);
	gtk_container_add(GTK_CONTAINER(toolbar), save_as_button);

	GtkToolItem * group1_separator;
	group1_separator = gtk_separator_tool_item_new();
	gtk_widget_show(GTK_WIDGET(group1_separator));
	gtk_toolbar_insert(GTK_TOOLBAR(toolbar), group1_separator, -1);

	GdkPixbuf * cut_pixbuf;
	GtkWidget * cut_image;
	cut_pixbuf = gdk_pixbuf_new_from_xpm_data((const char **) cut_xpm);
	cut_image = gtk_image_new_from_pixbuf(cut_pixbuf);
	gtk_widget_show(cut_image);

	GtkWidget * cut_button;
	cut_button = (GtkWidget *) gtk_tool_button_new(cut_image, "cut");
	gtk_tool_item_set_tooltip(GTK_TOOL_ITEM(cut_button), GTK_TOOLTIPS(tips), "cut", NULL);
	gtk_widget_show(cut_button);
	gtk_container_add(GTK_CONTAINER(toolbar), cut_button);

	GdkPixbuf * copy_pixbuf;
	GtkWidget * copy_image;
	copy_pixbuf = gdk_pixbuf_new_from_xpm_data((const char **) copy_xpm);
	copy_image = gtk_image_new_from_pixbuf(copy_pixbuf);
	gtk_widget_show(copy_image);

	GtkWidget * copy_button;
	copy_button = (GtkWidget *) gtk_tool_button_new(copy_image, "copy");
	gtk_tool_item_set_tooltip(GTK_TOOL_ITEM(copy_button), GTK_TOOLTIPS(tips), "copy", NULL);
	gtk_widget_show(copy_button);
	gtk_container_add(GTK_CONTAINER(toolbar), copy_button);

	GdkPixbuf * paste_pixbuf;
	GtkWidget * paste_image;
	paste_pixbuf = gdk_pixbuf_new_from_xpm_data((const char **) paste_xpm);
	paste_image = gtk_image_new_from_pixbuf(paste_pixbuf);
	gtk_widget_show(paste_image);

	GtkWidget * paste_button;
	paste_button = (GtkWidget *) gtk_tool_button_new(paste_image, "paste");
	gtk_tool_item_set_tooltip(GTK_TOOL_ITEM(paste_button), GTK_TOOLTIPS(tips), "paste", NULL);
	gtk_widget_show(paste_button);
	gtk_container_add(GTK_CONTAINER(toolbar), paste_button);

	GtkToolItem * group2_separator;
	group2_separator = gtk_separator_tool_item_new();
	gtk_widget_show(GTK_WIDGET(group2_separator));
	gtk_toolbar_insert(GTK_TOOLBAR(toolbar), group2_separator, -1);

	GdkPixbuf * about_pixbuf;
	GtkWidget * about_image;
	about_pixbuf = gdk_pixbuf_new_from_xpm_data((const char **) about_xpm);
	about_image = gtk_image_new_from_pixbuf(about_pixbuf);
	gtk_widget_show(about_image);

	GtkWidget * about_button;
	about_button = (GtkWidget *) gtk_tool_button_new(about_image, "about");
	gtk_tool_item_set_tooltip(GTK_TOOL_ITEM(about_button), GTK_TOOLTIPS(tips), "about", NULL);
	gtk_widget_show(about_button);
	gtk_container_add(GTK_CONTAINER(toolbar), about_button);

	GtkWidget * scroll;
	scroll = gtk_scrolled_window_new(NULL, NULL);
	gtk_widget_show(scroll);
	gtk_table_attach(GTK_TABLE(table), scroll, 0, 1, 1, 2, (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	
	view = gtk_text_view_new();
	buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(view));
	gtk_widget_show(view);
	gtk_container_add(GTK_CONTAINER(scroll), view);
	gtk_widget_grab_focus(view);

	PangoFontDescription * font_desc;
	font_desc = pango_font_description_from_string("Monospace 10");
	gtk_widget_modify_font(view, font_desc);
	pango_font_description_free(font_desc);
	
	status = gtk_statusbar_new();
	gtk_widget_show(status);
	gtk_table_attach(GTK_TABLE(table), status, 0, 1, 2, 3, (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), (GtkAttachOptions) (0), 0, 0);
	gtk_statusbar_push(GTK_STATUSBAR(status), 0, " line: 1  col: 1");
	
	GtkAccelGroup * accel_group;
	GClosure * closure;
	guint key;
	GdkModifierType mods;
	accel_group = gtk_accel_group_new();
	
	closure = g_cclosure_new(G_CALLBACK(accel_ctrl_n), NULL, NULL);
	gtk_accelerator_parse("<CTRL>N", &key, &mods);
	gtk_accel_group_connect(accel_group, key, mods, GTK_ACCEL_VISIBLE, closure);
	g_closure_unref(closure);

	closure = g_cclosure_new(G_CALLBACK(accel_ctrl_o), NULL, NULL);
	gtk_accelerator_parse("<CTRL>O", &key, &mods);
	gtk_accel_group_connect(accel_group, key, mods, GTK_ACCEL_VISIBLE, closure);
	g_closure_unref(closure);

	closure = g_cclosure_new(G_CALLBACK(accel_ctrl_s), NULL, NULL);
	gtk_accelerator_parse("<CTRL>S", &key, &mods);
	gtk_accel_group_connect(accel_group, key, mods, GTK_ACCEL_VISIBLE, closure);
	g_closure_unref(closure);
	
	gtk_window_add_accel_group(GTK_WINDOW(zedit_window), accel_group);

	// connect signals
	g_signal_connect(GTK_OBJECT(zedit_window), "delete_event", GTK_SIGNAL_FUNC(zedit_unload), NULL);
	g_signal_connect(GTK_OBJECT(zedit_window), "destroy", GTK_SIGNAL_FUNC(zedit_destroy), NULL);
	g_signal_connect(GTK_OBJECT(new_button), "clicked", GTK_SIGNAL_FUNC(new_button_clicked), NULL);
	g_signal_connect(GTK_OBJECT(open_button), "clicked", GTK_SIGNAL_FUNC(open_button_clicked), NULL);
	g_signal_connect(GTK_OBJECT(save_button), "clicked", GTK_SIGNAL_FUNC(save_button_clicked), NULL);
	g_signal_connect(GTK_OBJECT(save_as_button), "clicked", GTK_SIGNAL_FUNC(save_as_button_clicked), NULL);
	g_signal_connect(GTK_OBJECT(cut_button), "clicked", GTK_SIGNAL_FUNC(cut_button_clicked), NULL);
	g_signal_connect(GTK_OBJECT(copy_button), "clicked", GTK_SIGNAL_FUNC(copy_button_clicked), NULL);
	g_signal_connect(GTK_OBJECT(paste_button), "clicked", GTK_SIGNAL_FUNC(paste_button_clicked), NULL);
	g_signal_connect(GTK_OBJECT(about_button), "clicked", GTK_SIGNAL_FUNC(about_button_clicked), NULL);
	g_signal_connect(GTK_TEXT_BUFFER(buffer), "changed", GTK_SIGNAL_FUNC(buffer_changed), NULL);
	g_signal_connect(GTK_TEXT_BUFFER(buffer), "mark_set", G_CALLBACK(buffer_mark_set), view);

	gtk_widget_show(zedit_window);
}
